/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.weex.ui.view.listview.adapter;

import android.support.v7.widget.RecyclerView;
import android.view.ViewGroup;

/**
 * Listener for recyclerView event
 */
public interface IRecyclerAdapterListener<T extends RecyclerView.ViewHolder> {

  void onViewRecycled(T holder);

  void onBindViewHolder(T holder, int position);

  T onCreateViewHolder(ViewGroup parent, int viewType);

  int getItemViewType(int position);

  int getItemCount();

  boolean onFailedToRecycleView(T holder);

  long getItemId(int position);
}
